DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Attributes | Static Private Attributes | List of all members
IODGeneralStudyModule Class Reference

Class representing the General Study Module: Notation is "Attribute Name: (VR, VM, Type)". More...

Inheritance diagram for IODGeneralStudyModule:

## Public Member Functions
| IODGeneralStudyModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor. More...
| IODGeneralStudyModule ()
| Constructor.
virtual | ~IODGeneralStudyModule ()
| Destructor.
virtual void | inventMissing ()
| Set missing values by inventing "default values". More...
virtual void | resetRules ()
| Resets rules to their original values.
virtual OFString | getName () const
| Get name of module. More...
virtual void | clearData ()
| Clear (removes) all attributes handled by the modules of this component. More...
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read data into this module from given item. More...
virtual OFCondition | write (DcmItem &destination)
| Write this module to given item. More...
virtual void | ensureInstanceUID (const OFBool correctInvalid=OFFalse)
| Make sure that the module contains a Study Instance UID, i.e. a new one is created if empty. More...
virtual OFCondition | getStudyInstanceUID (OFString &value, const signed long pos=0) const
| Get Study Instance UID. More...
virtual OFCondition | getStudyDate (OFString &value, const signed long pos=0) const
| Get Study Date. More...
virtual OFCondition | getStudyTime (OFString &value, const signed long pos=0) const
| Get Study Time. More...
virtual OFCondition | getReferringPhysicianName (OFString &value, const signed long pos=0) const
| Get Referring Physician's Name. More...
virtual OFCondition | getStudyID (OFString &value, const signed long pos=0) const
| Get Study ID. More...
virtual OFCondition | getAccessionNumber (OFString &value, const signed long pos=0) const
| Get Accession Number. More...
virtual OFCondition | getStudyDescription (OFString &value, const signed long pos=0) const
| Get Study Description. More...
virtual HL7HierarchicDesignatorMacro & | getIssuerOfAccessionNumber ()
| Get reference to content of Issuer of Accession Number Sequence. More...
virtual OFVector< CodeSequenceMacro * > & | getProcedureCodeSequence ()
| Get reference to content of Procedure Code Sequence. More...
virtual OFVector< CodeSequenceMacro * > & | getReasonForPerformedProcedureCodeSequence ()
| Get reference to content of Reason for Performed Procedure Code Sequence. More...
virtual OFCondition | setStudyInstanceUID (const OFString &value, const OFBool checkValue=OFTrue)
| Set Study Instance UID. More...
virtual OFCondition | setStudyDate (const OFString &value, const OFBool checkValue=OFTrue)
| Set Study Date. More...
virtual OFCondition | setStudyTime (const OFString &value, const OFBool checkValue=OFTrue)
| set study time More...
virtual OFCondition | setReferringPhysicianName (const OFString &value, const OFBool checkValue=OFTrue)
| Set Referring Physician's Name. More...
virtual OFCondition | setStudyID (const OFString &value, const OFBool checkValue=OFTrue)
| Set Study ID. More...
virtual OFCondition | setAccessionNumber (const OFString &value, const OFBool checkValue=OFTrue)
| Set Accession Number. More...
virtual OFCondition | setStudyDescription (const OFString &value, const OFBool checkValue=OFTrue)
| Set Study Description. More...
Public Member Functions inherited from IODModule
| IODModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor. More...
| IODModule ()
| Constructor. More...
| IODModule (const IODModule &rhs)
| Copy constructor, creates shallow copy. More...
IODModule & | operator= (const IODModule &rhs)
| Assignment operator, creates shallow copy. More...
| ~IODModule ()
| Destructor.
Public Member Functions inherited from IODComponent
| IODComponent (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor. More...
| IODComponent (IODComponent *parent=NULL)
| Constructor, creates rules and item from scratch. More...
IODComponent & | operator= (const IODComponent &rhs)
| Assignment operator, copies contained item and rule set from rhs to "this" attribute set. More...
| IODComponent (const IODComponent &rhs)
| Copy constructor, copies reference to contained item and rule set to "this" attribute set. More...
virtual | ~IODComponent ()
| Virtual Destructor.
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this module. More...
virtual void | makeOptional ()
| Make component optional by turning all attributes requirement types of it to type 3. More...
DcmItem & | getData ()
| Get the data handled by this module. More...
virtual OFCondition | check (const OFBool quiet=OFFalse)
| Check whether this component's data satisfies the underlying rules. More...
virtual int | compare (const IODComponent &rhs) const
| Comparison operator for IOD Components. More...
virtual bool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing. More...
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e. More...

## Private Attributes
HL7HierarchicDesignatorMacro | m_IssuerOfAccessionNumberSequence
| Issuer of Accession Number Sequence.
OFVector< CodeSequenceMacro * > | m_ProcedureCodeSequence
| Procedure Code Sequence.
OFVector< CodeSequenceMacro * > | m_ReasonForPerformedProcedureCodeSequence
| Reason for Performed Procedure Code Sequence.

## Static Private Attributes
static const OFString | m_ModuleName
| Name of this module ("GeneralStudyModule")

## Additional Inherited Members
Static Public Member Functions inherited from IODComponent
static OFCondition | read (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName)
| Static helper function that reads attributes from given item into destination item, as determined by the provided rules and component name. More...
static OFCondition | write (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName, const OFBool checkValue)
| Static helper function that writes attributes from given item into destination item, as determined by the provided rules and component name. More...
Protected Attributes inherited from IODComponent
OFshared_ptr< DcmItem > | m_Item
| Shared pointer to the data handled by this class. More...
OFshared_ptr< IODRules > | m_Rules
| Rules describing the attributes governed by this class.
IODComponent * | m_Parent
| The parent component (may be NULL) of this class.
OFBool | m_CheckValueOnWrite
| Denotes whether attribute values should be checked on writing, i.e. More...

## Detailed Description

Class representing the General Study Module: Notation is "Attribute Name: (VR, VM, Type)".

Study Instance UID: (UI, 1, 1) Study Date: (DA, 1, 2) Study Time: (TM, 1, 2) Referring Physician's Name: (PN, 1, 2) Study ID: (SH, 1, 2) Accession Number: (SH, 1, 2) Study Description: (LO, 1, 3) Issuer of Accession Number Sequence: (SQ, 1, 3) Procedure Code Sequence: (SQ, 1-n, 3) Reason for Performed Procedure Code Sequence: (SQ, 1-n, 3)

## Constructor & Destructor Documentation

## ◆ IODGeneralStudyModule()

IODGeneralStudyModule::IODGeneralStudyModule | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules
| ) |  |

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.

## Member Function Documentation

## ◆ clearData()

virtual void IODGeneralStudyModule::clearData | ( |  | ) |
| virtual

Clear (removes) all attributes handled by the modules of this component.

Rules are not reset.

Reimplemented from IODComponent.

## ◆ ensureInstanceUID()

virtual void IODGeneralStudyModule::ensureInstanceUID | ( | const OFBool | correctInvalid = `OFFalse` | ) |
| virtual

Make sure that the module contains a Study Instance UID, i.e. a new one is created if empty.

An invalid UID is corrected if desired.

Parameters

  correctInvalid | Correct invalid UID if OFTrue, otherwise do nothing

## ◆ getAccessionNumber()

virtual OFCondition IODGeneralStudyModule::getAccessionNumber | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Accession Number.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getIssuerOfAccessionNumber()

virtual HL7HierarchicDesignatorMacro& IODGeneralStudyModule::getIssuerOfAccessionNumber | ( |  | ) |
| virtual

Get reference to content of Issuer of Accession Number Sequence.

Returns
  Reference to single item of Issuer of Accession Number Sequence

## ◆ getName()

virtual OFString IODGeneralStudyModule::getName | ( |  | ) | const
| virtual

Get name of module.

Returns
  Name of the module ("GeneralStudyModule")

Implements IODComponent.

## ◆ getProcedureCodeSequence()

virtual OFVector<CodeSequenceMacro*>& IODGeneralStudyModule::getProcedureCodeSequence | ( |  | ) |
| virtual

Get reference to content of Procedure Code Sequence.

Returns
  Reference to items of Procedure Code Sequence

## ◆ getReasonForPerformedProcedureCodeSequence()

virtual OFVector<CodeSequenceMacro*>& IODGeneralStudyModule::getReasonForPerformedProcedureCodeSequence | ( |  | ) |
| virtual

Get reference to content of Reason for Performed Procedure Code Sequence.

Returns
  Reference to items of Procedure Code Sequence

## ◆ getReferringPhysicianName()

virtual OFCondition IODGeneralStudyModule::getReferringPhysicianName | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Referring Physician's Name.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getStudyDate()

virtual OFCondition IODGeneralStudyModule::getStudyDate | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Study Date.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getStudyDescription()

virtual OFCondition IODGeneralStudyModule::getStudyDescription | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Study Description.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getStudyID()

virtual OFCondition IODGeneralStudyModule::getStudyID | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Study ID.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getStudyInstanceUID()

virtual OFCondition IODGeneralStudyModule::getStudyInstanceUID | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Study Instance UID.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getStudyTime()

virtual OFCondition IODGeneralStudyModule::getStudyTime | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Study Time.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ inventMissing()

virtual void IODGeneralStudyModule::inventMissing | ( |  | ) |
| virtual

Set missing values by inventing "default values".

Automatically called during write() by IODComponent.

Reimplemented from IODComponent.

## ◆ read()

virtual OFCondition IODGeneralStudyModule::read | ( | DcmItem & | source,
|  | const OFBool | clearOldData = `OFTrue`
| ) |  |
| virtual

Read data into this module from given item.

Parameters

  source | The item to read from
  clearOldData | If OFTrue, old data in this module is cleared first (default: OFTrue)

Returns
  EC_Normal if reading was successful, error otherwise

Reimplemented from IODComponent.

## ◆ setAccessionNumber()

virtual OFCondition IODGeneralStudyModule::setAccessionNumber | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Accession Number.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (SH) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setReferringPhysicianName()

virtual OFCondition IODGeneralStudyModule::setReferringPhysicianName | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Referring Physician's Name.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (PN) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setStudyDate()

virtual OFCondition IODGeneralStudyModule::setStudyDate | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Study Date.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (DA) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setStudyDescription()

virtual OFCondition IODGeneralStudyModule::setStudyDescription | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Study Description.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setStudyID()

virtual OFCondition IODGeneralStudyModule::setStudyID | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Study ID.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (SH) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setStudyInstanceUID()

virtual OFCondition IODGeneralStudyModule::setStudyInstanceUID | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Study Instance UID.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (UI) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setStudyTime()

virtual OFCondition IODGeneralStudyModule::setStudyTime | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

set study time

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (TM) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ write()

virtual OFCondition IODGeneralStudyModule::write | ( | DcmItem & | destination | ) |
| virtual

Write this module to given item.

Parameters

  destination | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise

Reimplemented from IODComponent.

The documentation for this class was generated from the following file:

- dcmiod/include/dcmtk/dcmiod/modgeneralstudy.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1